//
//  DSIntervalPicker.h
//  DSInterval
//
//  Created by David Sinclair on 2008-07-11.
//  Copyright 2008 Dejal Systems, LLC. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without modification,
//  are permitted provided that the following conditions are met:
//  
//  Redistributions of source code must retain this list of conditions and the following disclaimer.
//  
//  The name of Dejal Systems, LLC may not be used to endorse or promote products derived from this
//  software without specific prior written permission.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
//  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//  PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE AUTHORS OR
//  COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
//  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//  SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
//

#import <Cocoa/Cocoa.h>
#import "DSInterval.h"
#import "DSIntervalPickerCell.h"


@interface DSIntervalPicker : NSControl
{
}

@property(readonly) DSIntervalPickerCell *pickerCell;
@property(copy) DSInterval *interval;
@property NSInteger firstAmount;
@property NSInteger secondAmount;
@property NSInteger amount;
@property DSIntervalUnits units;
@property(readonly) NSTimeInterval firstTimeInterval;
@property(readonly) NSTimeInterval secondTimeInterval;
@property(readonly) NSTimeInterval amountTimeInterval;
@property BOOL usingRange;
@property DSIntervalPickerRangeFiltering rangeFiltering;
@property NSInteger minimumAmount;
@property NSInteger maximumAmount;
@property BOOL includeSeconds;
@property BOOL includeMinutes;
@property BOOL includeHours;
@property BOOL includeDays;
@property BOOL includeWeeks;
@property BOOL includeMonths;
@property BOOL includeQuarters;
@property BOOL includeYears;
@property BOOL includeForever;
@property BOOL includeNever;

- (void)setupForShortTerm;
- (void)setupForLongTerm;
- (void)setupForAllUnits;

@end

