//
//  DSIntervalPickerIntegration.m
//  DSInterval
//
//  Created by David Sinclair on 2008-08-15.
//  Copyright 2008 Dejal Systems, LLC. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without modification,
//  are permitted provided that the following conditions are met:
//  
//  Redistributions of source code must retain this list of conditions and the following disclaimer.
//  
//  The name of Dejal Systems, LLC may not be used to endorse or promote products derived from this
//  software without specific prior written permission.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
//  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//  PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE AUTHORS OR
//  COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
//  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//  SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
//

#import <InterfaceBuilderKit/InterfaceBuilderKit.h>
#import <DSInterval/DSIntervalPicker.h>
#import "DSIntervalInspector.h"


@implementation DSIntervalPicker (DSIntervalIntegration)

- (void)ibPopulateKeyPaths:(NSMutableDictionary *)keyPaths;
{
    [super ibPopulateKeyPaths:keyPaths];
	
	// The control's KVC-compliant properties:
    [[keyPaths objectForKey:IBAttributeKeyPaths] addObjectsFromArray:[NSArray arrayWithObjects:@"firstAmount", @"secondAmount", @"amount", @"units", @"usingRange", nil]];
}

- (void)ibPopulateAttributeInspectorClasses:(NSMutableArray *)classes;
{
    [super ibPopulateAttributeInspectorClasses:classes];
    
    [classes addObject:[DSIntervalInspector class]];
}

@end
