//
//  DSAttributedStringCategories.h
//  Shared categories
//
//  Created by David Sinclair on Fri Jul 18 2003.
//  Copyright � 2003 - 2007 Dejal Systems, LLC. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without modification,
//  are permitted provided that the following conditions are met:
//  
//  Redistributions of source code must retain this list of conditions and the following disclaimer.
//  
//  The name of Dejal Systems, LLC may not be used to endorse or promote products derived from this
//  software without specific prior written permission.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
//  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//  PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE AUTHORS OR
//  COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
//  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//  SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
//


@interface NSAttributedString (DSAttributedStringCategories)

+ (id)attributedString;
+ (id)attributedStringWithString:(NSString *)string;
+ (id)attributedStringWithString:(NSString *)string attributes:(NSDictionary *)attributes;
+ (id)attributedStringWithImageFromPath:(NSString *)path;
+ (id)attributedStringWithRTF:(NSData *)data;
+ (id)attributedStringWithRTFD:(NSData *)data;


// ----------------------------------------------------------------------------------------
#pragma mark -
// ----------------------------------------------------------------------------------------


- (NSRange)allRange;

- (NSData *)RTFValue;
- (NSData *)RTFDValue;
- (NSData *)textViewBindingsValue;

@end


// ----------------------------------------------------------------------------------------
#pragma mark -
// ----------------------------------------------------------------------------------------


@interface NSMutableAttributedString (DSMutableAttributedStringCategories)

- (void)appendString:(NSString *)string withAttributes:(NSDictionary *)attributes;
- (void)insertString:(NSString *)string withAttributes:(NSDictionary *)attributes atIndex:(NSUInteger)i;

@end

