//
//  DSObjectCategories.h
//  Shared categories
//
//  Created by David Sinclair on Tue Sep 24 2002.
//  Copyright � 2002 - 2007 Dejal Systems, LLC. All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without modification,
//  are permitted provided that the following conditions are met:
//  
//  Redistributions of source code must retain this list of conditions and the following disclaimer.
//  
//  The name of Dejal Systems, LLC may not be used to endorse or promote products derived from this
//  software without specific prior written permission.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
//  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//  PURPOSE AND NONINFRINGEMENT OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE AUTHORS OR
//  COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
//  ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
//  SOFTWARE OR THE USE OR OTHER DEALINGS IN THIS SOFTWARE.
//


@interface NSObject (DSObjectFoundationCategories)

- (void)set:(id *)iVar to:(id)value;
- (void)set:(id *)iVar to:(id)value nilAllowed:(BOOL)flag;

- (BOOL)isReallySubclassOfClass:(Class)aClass;

- (BOOL)isEquivalent:(id)anObject;
- (BOOL)isEquivalentTo:(id)anObject;

- (BOOL)performBoolSelector:(SEL)selector;
- (BOOL)performBoolSelector:(SEL)selector withObject:(id)object;
- (BOOL)performBoolSelector:(SEL)selector withObject:(id)object1 withObject:(id)object2;

- (NSInteger)performIntegerSelector:(SEL)selector;
- (NSInteger)performIntegerSelector:(SEL)selector withObject:(id)object;
- (NSInteger)performIntegerSelector:(SEL)selector withObject:(id)object1 withObject:(id)object2;

- (void)performSelector:(SEL)selector withWindow:(NSWindow *)window returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo;

- (void)performSelector:(SEL)selector withArguments:(NSArray *)arguments;

- (void)performSelector:(SEL)selector withEachObjectInArray:(NSArray *)array;
- (void)performSelector:(SEL)selector withEachObjectInDictionary:(NSDictionary *)dict;
- (void)performSelector:(SEL)selector withEachObjectInSet:(NSSet *)set;

@end


// ----------------------------------------------------------------------------------------
#pragma mark -
// ----------------------------------------------------------------------------------------


@interface NSObject (DSObjectAppKitCategories)

- (BOOL)usedCommandModifier;
- (BOOL)usedOptionModifier;
- (BOOL)usedShiftModifier;
- (BOOL)usedControlModifier;

@end
