//
//  MainController.m
//  DSIntervalPicker
//
//  Created by David Sinclair on 2008-07-11.
//  Copyright 2008 Dejal Systems, LLC. All rights reserved.
//

#import "MainController.h"
#import <DSInterval/DSInterval.h>


@implementation MainController

- (void)setupTableIntervalColumnWithIdentifier:(NSString *)identifier makeRange:(BOOL)makeRange;
{
    NSTableColumn *column = [tableView tableColumnWithIdentifier:identifier];
    DSIntervalPickerCell *cell = [[[DSIntervalPickerCell alloc] init] autorelease];
    
    if (makeRange)
        cell.usingRange = YES;
    
    [column setDataCell:cell];
}

- (void)awakeFromNib;
{
//    intervalPicker1.amount = 2;
//    intervalPicker1.units = UNITS_HOUR;
    intervalPicker1.includeForever = YES;
    intervalPicker1.includeNever = YES;
    
    [intervalPicker2 setupForLongTerm];
    intervalPicker2.usingRange = YES;
//    [intervalPicker2 setRangeFiltering:DSIntervalFirstGreaterThanSecond];
    [intervalPicker2 setMinimumAmount:10];
    [intervalPicker2 setMaximumAmount:99];
    [intervalPicker2 setFirstAmount:15];
    [intervalPicker2 setSecondAmount:30];
    intervalPicker2.includeNever = YES;
//    [intervalPicker2 setUnits:UNITS_SECOND];
//    [intervalPicker2 setEnabled:NO];
    
    [self setupTableIntervalColumnWithIdentifier:@"singleInterval" makeRange:NO];
    [self setupTableIntervalColumnWithIdentifier:@"rangeInterval" makeRange:YES];
}

@end
