//
//  DSAlertController.m
//  BlogAssist
//
//  Created by David Sinclair on 2006-01-21.
//  Copyright 2006 Dejal Systems, LLC. All rights reserved.
//

#import "DSAlertController.h"




/*
 ¶¶ Development Notes:
 
 - see usage example in -[DSPreferencesController selectPageWithIdentifier:] -- there are some issues, including having to coerce the -alertWithMessageText::: result.
 - also can't call [super buttonPressed:] as it isn't a public method; only know about it by looking in NSAlertPanel.nib in AppKit.framework.
 - may be merit in doing it as a DSSheetController subclass after all; then it's all under my control, and I just have to implement the resizing of the window to fit the explanation text; can just make that text field vertically sizable, and resize the window a suitable (?) amount.
 - if I do it myself, base the Nib on Apple's.
 - main goal is to have the option of an alert that is modeless, and possibly comes up in front of all other apps windows (for agents like BlogAssist).  Must also support working as a sheet, too.
*/




@implementation DSAlertController

/*
 beginWindowWithModelessDelegate:didEndSelector:contextInfo:
 
 Shows the alert window modelessly.  When the window ends (i.e. the OK or Cancel button is clicked), the method with the specified selector in the modeless delegate is invoked.  All parameters are optional.  Returns the receiver.  If used, the didEndSelector method should have the following signature; returnCode will be one of NSAlertDefaultReturn, NSAlertAlternateReturn, NSAlertOtherReturn, or NSAlertErrorReturn (which correspond to the NSAlert[...]Return values, and the older NSOKButton/NSCancelButton values).  N.B. that unlike the DSSheetController, the first parameter is the controller, not the window:
 
 - (void)alertDidEnd:(DSAlertController *)alert returnCode:(NSInteger)returnCode contextInfo:(void *)contextInfo;
 
 Written by DJS 2006-01.
*/

- (id)beginWindowWithModelessDelegate:(id)modelessDelegate didEndSelector:(SEL)didEndSelector contextInfo:(void *)contextInfo;
{
//    [self setDSModelessDelegate:modelessDelegate];
//    [self setDSDidEndSelector:didEndSelector];
//    [self setDSContextInfo:contextInfo];
    
//    [self showWindow:nil];
    
    return self;
}


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark TARGET/ACTION METHODS
// ----------------------------------------------------------------------------------------

/*
- (IBAction)buttonPressed:(id)sender;
{
    [super buttonPressed:sender];
}
*/


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------


@end
