/* DSPasswordDecryptController */


#import "DSSheetController.h"


@interface DSPasswordDecryptController : DSSheetController
{
    NSMutableDictionary *_encryption;
    id _encryptionDelegate;
    SEL _validatePasswordSelector;
    int _attemptsRemaining;
    NSString *_enteredPassword;
    
    IBOutlet NSImageView *messageIcon;
    IBOutlet NSTextField *messageStat;
    IBOutlet NSSecureTextField *passwordField;
}

- (void)beginSheetForName:(NSString *)name encryption:(NSMutableDictionary *)encryption 
       encryptionDelegate:(id)encryptionDelegate validatePasswordSelector:(SEL)validatePasswordSelector
           modalForWindow:(NSWindow *)docWindow modalDelegate:(id)modalDelegate didEndSelector:(SEL)didEndSelector contextInfo:(void *)contextInfo;

- (void)beginSheetForName:(NSString *)name encryption:(NSMutableDictionary *)encryption tryPassword:(NSString *)tryPassword
       encryptionDelegate:(id)encryptionDelegate validatePasswordSelector:(SEL)validatePasswordSelector
           modalForWindow:(NSWindow *)docWindow modalDelegate:(id)modalDelegate didEndSelector:(SEL)didEndSelector contextInfo:(void *)contextInfo;

- (void)beginSheetForEncryption:(NSMutableDictionary *)encryption
             encryptionDelegate:(id)encryptionDelegate validatePasswordSelector:(SEL)validatePasswordSelector
                 modalForWindow:(NSWindow *)docWindow modalDelegate:(id)modalDelegate didEndSelector:(SEL)didEndSelector contextInfo:(void *)contextInfo;

- (void)beginSheetForEncryption:(NSMutableDictionary *)encryption tryPassword:(NSString *)tryPassword
             encryptionDelegate:(id)encryptionDelegate validatePasswordSelector:(SEL)validatePasswordSelector
                 modalForWindow:(NSWindow *)docWindow modalDelegate:(id)modalDelegate didEndSelector:(SEL)didEndSelector contextInfo:(void *)contextInfo;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark TARGET/ACTION METHODS
// ----------------------------------------------------------------------------------------

- (IBAction)passwordFieldHit:(id)sender;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSMutableDictionary *)encryption;
- (void)setEncryption:(NSMutableDictionary *)value;

- (id)encryptionDelegate;
- (void)setEncryptionDelegate:(id)value;

- (SEL)validatePasswordSelector;
- (void)setValidatePasswordSelector:(SEL)value;

- (int)attemptsRemaining;
- (void)decrementAttemptsRemaining;

- (NSString *)enteredPassword;
- (void)setEnteredPassword:(NSString *)value;

@end
