/* SharedController */


@interface DSSharedController : NSObject
{
    BOOL _fullyStarted;
    BOOL _quitting;

    NSUInteger dockIconAnimation;
    NSDate *dockIconDate;
    NSMutableArray *dockIconAnimationArray;
    NSTimer *dockIconAnimationTimer;
}

+ (id)mainController;

- (NSArray *)preferenceClasses;

- (NSMutableDictionary *)defaultPreferences;

- (void)upgradePreferences;
- (NSInteger)upgradePreferencesFromVersion:(NSInteger)preferencesVersion;

- (NSDictionary *)setupAssistantSettings;

- (BOOL)loadInitialApplicationData;
- (BOOL)displayInitialApplicationViews;


- (BOOL)validateMenuItem:(NSMenuItem *)menuItem;

- (void)setMustQuitWithoutConfirmation;

- (BOOL)fullyStarted;
- (void)setFullyStarted:(BOOL)value;

- (BOOL)isQuitting;
- (void)setQuitting:(BOOL)value;

- (NSString *)dataFolderPath;
- (NSString *)uniqueTemporaryDataPath;
- (NSString *)temporaryDataPath;
- (NSString *)temporaryDataPathWithoutCreating;


@property (getter=isQuitting,setter=setQuitting:) BOOL _quitting;
@property (getter=fullyStarted,setter=setFullyStarted:) BOOL _fullyStarted;
@property (retain) NSDate *dockIconDate;
@property NSUInteger dockIconAnimation;
@property (retain) NSTimer *dockIconAnimationTimer;
@property (retain) NSMutableArray *dockIconAnimationArray;
@end

