#import "DSSharedPrefDefines.h"


// Language (localization):

#define LANGUAGE_CODE           NSLocalizedStringFromTable(@"en", @"DSShared", @"Short code for the language (localization)")
#define LANGUAGE_ENGLISH_NAME   NSLocalizedStringFromTable(@"English", @"DSShared", @"English name for the language")
#define LANGUAGE_LOCAL_NAME     NSLocalizedStringFromTable(@"English", @"DSShared", @"Localized name for the language")


// Command identifiers (used for toolbars and menus):

#define CMD_SHOW_TOOLBAR        NSLocalizedStringFromTable(@"Show Toolbar", @"DSShared", @"Show Toolbar")
#define CMD_HIDE_TOOLBAR        NSLocalizedStringFromTable(@"Hide Toolbar", @"DSShared", @"Hide Toolbar")
#define CMD_ADD                 @"DSSharedAdd"
#define CMD_ALTER               @"DSSharedAlter"
#define CMD_DELETE              @"DSSharedDelete"
#define CMD_EMAIL_CARDS         @"DSSharedEmailCards"
#define CMD_EXPORT_CARDS        @"DSSharedExportCards"
#define CMD_ENCRYPT_CARD        @"DSSharedEncryptCard"
#define CMD_PRINT               @"DSSharedPrint"
#define CMD_FONT_PANEL          @"DSSharedFontPanel"
#define CMD_FONT_BOLD           @"DSSharedFontBold"
#define CMD_FONT_ITALIC         @"DSSharedFontItalic"
#define CMD_FONT_UNDERLINE      @"DSSharedFontUnderline"
#define CMD_FONT_STRIKE         @"DSSharedFontStrikeout"
#define CMD_COLORS              @"DSSharedColors"
#define CMD_ALIGN_LEFT          @"DSSharedAlignLeft"
#define CMD_ALIGN_CENTER        @"DSSharedAlignCenter"
#define CMD_ALIGN_JUSTIFY       @"DSSharedAlignJustify"
#define CMD_ALIGN_RIGHT         @"DSSharedAlignRight"
#define CMD_CHECK_SPELLING      @"DSSharedCheckSpelling"
#define CMD_MODE_TOGGLE         @"DSSharedModeToggle"
#define CMD_SEARCH              @"DSSharedSearch"
#define CMD_SOFTWARE_UPDATE     NSLocalizedStringFromTable(@"Check for Updates...", @"DSShared", @"Check for Updates...")
#define CMD_PREFERENCES         NSLocalizedStringFromTable(@"Preferences...", @"DSShared", @"Preferences...")
#define CMD_FEEDBACK            NSLocalizedStringFromTable(@"Forums", @"DSShared", @"Forums")
#define CMD_GUIDE               NSLocalizedStringFromTable(@"User Guide", @"DSShared", @"User Guide")


// View modes (pref values, tab view identifiers, and image names):

#define VIEW_MODE_LOADING       @"ViewModeLoading"
#define VIEW_MODE_ICONS         @"ViewModeIcons"
#define VIEW_MODE_LIST          @"ViewModeList"
#define VIEW_MODE_COLUMNS       @"ViewModeColumns"
#define VIEW_MODE_SEARCH        @"ViewModeSearch"


// Password sheet defines:

#define DSPASSWORD_BACKDOOR_CHECKSUM    [NSNumber numberWithFloat:1.5]


// URLs; if URL_OVERRIDE is defined, these are defined elsewhere:

#ifndef URL_OVERRIDE

#define COMPANY_NAME_NORMAL         NSLocalizedStringFromTable(@"Dejal", @"DSShared", @"Normal name of company")
#define COMPANY_NAME_BRIEF          NSLocalizedStringFromTable(@"Dejal", @"DSShared", @"Brief name of company")
#define URL_COMPANY_EMAIL           NSLocalizedStringFromTable(@"mailto:info@dejal.com", @"DSShared", @"Email address for the company")
#define URL_PRODUCT_EMAIL           [URL_COMPANY_EMAIL stringByAppendingFormat:NSLocalizedStringFromTable(@"?subject=%@....", @"DSShared", @"Email param"), PRODUCT_NAME]

#define URL_COMPANY_SITE            @"http://www.dejal.com/"
#define URL_COMPANY_PRODUCT_SITE    [URL_COMPANY_SITE stringByAppendingFormat:@"%@/", PRODUCT_PARAM]
#define URL_GOTO                    [URL_COMPANY_SITE stringByAppendingFormat:@"goto/?lang=%@", LANGUAGE_CODE]
#define URL_PRODUCT_SITE            [URL_GOTO stringByAppendingFormat:@"&prod=%@&ed=%@", PRODUCT_PARAM, PRODUCT_EDITION_PARAM]
#define URL_PRODUCT_RELEASE         [URL_PRODUCT_SITE stringByAppendingFormat:@"&page=release&rel=%@&from=%@", PRODUCT_RELEASE_KIND, PRODUCT_RELEASE]
#define URL_PRODUCT_FEEDBACK        [URL_PRODUCT_SITE stringByAppendingString:@"&page=forums"]
#define URL_PRODUCT_EXTRAS          [URL_PRODUCT_SITE stringByAppendingString:@"&page=extras"]
#define URL_PRODUCT_GUIDE           [URL_PRODUCT_SITE stringByAppendingString:@"&page=guide"]
#define URL_PRODUCTS                [URL_GOTO stringByAppendingString:@"&page=products"]
#define URL_ORDERS                  [URL_PRODUCT_SITE stringByAppendingFormat:@"&page=store&lic=%@&ref=%@app", [[DSLicenseController sharedLicenseController] storeParam], PRODUCT_PARAM]
#define URL_TRIALPAY                [URL_PRODUCT_SITE stringByAppendingFormat:@"&page=trialpay&lic=%@&ref=%@app", [[DSLicenseController sharedLicenseController] storeParam], PRODUCT_PARAM]
#define URL_SUPPORT                 [URL_PRODUCT_SITE stringByAppendingString:@"&page=support"]
#define URL_CONTACT                 [URL_PRODUCT_SITE stringByAppendingFormat:@"&page=contact&ref=%@app", PRODUCT_PARAM]
#define URL_NEWSLETTER              [URL_GOTO stringByAppendingString:@"&page=dejalnews&part=subscribe"]
#define URL_BLOG                    [URL_GOTO stringByAppendingString:@"&page=blog"]
#define URL_FORUMS                  [URL_PRODUCT_SITE stringByAppendingString:@"&page=forums"]
#define URL_PIRACY                  [URL_PRODUCT_SITE stringByAppendingString:@"&page=cracks"]
#define URL_VERSION_TRACKER         [URL_PRODUCT_SITE stringByAppendingString:@"&page=versiontracker"]
#define URL_MAC_UPDATE              [URL_PRODUCT_SITE stringByAppendingString:@"&page=macupdate"]
#define URL_IUSETHIS                [URL_PRODUCT_SITE stringByAppendingString:@"&page=iusethis"]


// Help book paths:

#define HELP_BOOK_NAME              [PRODUCT_NAME stringByAppendingString:@" Help"]
#define HELP_BOOK_ROOT              NSLocalizedStringFromTable(@"", @"DSShared", @"Help book root")

#define HELP_LICENCE_AGREE          NSLocalizedStringFromTable(@"license_agreement.htm", @"DSShared", @"Help book")
#define HELP_LICENCE_OPTIONS        NSLocalizedStringFromTable(@"license_options.htm", @"DSShared", @"Help book")
#define HELP_LICENCE_EDITOR         NSLocalizedStringFromTable(@"license_editor.htm", @"DSShared", @"Help book")
#define HELP_LICENCE_THANKS         NSLocalizedStringFromTable(@"license_thanks.htm", @"DSShared", @"Help book")
#define HELP_SETUP_ASSISTANT        NSLocalizedStringFromTable(@"setup_assistant.htm", @"DSShared", @"Help book")
#define HELP_PREFS_GENERAL          NSLocalizedStringFromTable(@"prefs_general.htm", @"DSShared", @"Help book")
#define HELP_PREFS_UPDATE           NSLocalizedStringFromTable(@"prefs_updates.htm", @"DSShared", @"Help book")
#define HELP_PREFS_ADVANCED         NSLocalizedStringFromTable(@"prefs_advanced.htm", @"DSShared", @"Help book")

#endif


