#import "DSSharedBaseDefines.h"
#import "SpecificDefines.h"
#import "DSCategories.h"


// Global instances:

#define PRODUCT_NAME [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleName"]
#define PRODUCT_VERSION [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"]
#define PRODUCT_RELEASE [[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleVersion"]
#define PRODUCT_MAJOR ([PRODUCT_RELEASE characterAtIndex:0] - '0')
#define PRODUCT_NAME_VERSION [NSString stringWithFormat:@"%@ %@", PRODUCT_NAME, PRODUCT_VERSION]
#define PRODUCT_RELEASE_KIND [PRODUCT_RELEASE length] == 4 ? @"gen" : @"beta"

#define COMPANY_PRODUCT_NAME [NSString stringWithFormat:@"%@ %@", COMPANY_NAME_BRIEF, PRODUCT_NAME]

#ifndef PRODUCT_EDITION_INT
#define PRODUCT_EDITION_INT             0
#define PRODUCT_EDITION_STRING          @"0"
#define PRODUCT_EDITION_PARAM           @"std"
#define PRODUCT_EDITION_NAME            @"Standard"
#endif


// Shared preferences:

#define SHARED_CONFIRM_QUIT             @"DSSharedConfirmQuit"
#define SHARED_QUIT_DATE                @"DSSharedQuitDate"

#define SHARED_CONFIRM_RESTORE_PREFS    @"DSSharedConfirmRestorePrefs"

#define PROGRESS_CYCLE_FREQUENCY        @"ProgressCycleFrequency"
#define PROGRESS_FINDERLIKE_ESTIMATES   @"ProgressFinderLikeEstimates"
#define PROGRESS_START_COLLAPSED        @"ProgressStartCollapsed"

#define SHARED_DATA_FOLDER_PATH         @"DSElementDataFolderPath"
#define SHARED_DATA_KEEP_BACKUP         @"DSElementDataKeepBackup"


// Software Update:

#define SU_CHECKED_VIA_SCHEDULE         2
#define SU_CHECKED_VIA_FIRST_USE        3
#define SU_CHECKED_VIA_ISSUE_TRACKING   4
#define SU_CHECKED_VIA_BETA_EXPIRY      5
#define SU_CHECKED_VIA_PREF_PANE        7
#define SU_CHECKED_VIA_TOOLBAR          8
#define SU_CHECKED_VIA_MENU             9
// 0 and 1 reserved for the legacy manual and automatic, not further defined; do not change any of these values

#define SU_MODE                         @"SoftwareUpdateMode"
#define SU_MODE_MANUAL                  0
#define SU_MODE_AUTOMATIC               1

#define SU_FREQUENCY                    @"SoftwareUpdateFrequency"
#define SU_FREQUENCY_DAILY              0
#define SU_FREQUENCY_WEEKLY             1
#define SU_FREQUENCY_MONTHLY            2

#define SU_LEVEL                        @"SoftwareUpdateLevel"
#define SU_LEVEL_GENERAL                0
#define SU_LEVEL_BETA                   1
#define SU_LEVEL_JENN                   6
#define SU_LEVEL_DANIEL                 7
#define SU_LEVEL_JASON                  8
#define SU_LEVEL_DAVID                  9

#define SU_DEFAULT_LEVEL                @"SoftwareUpdateDefaultLevel"

#define SU_LAST_CHECK                   @"SoftwareUpdateLastCheck"
#define SU_LAST_ATTEMPT                 @"SoftwareUpdateLastAttempt"
#define SU_LAST_MESSAGE                 @"SoftwareUpdateLastMessage"
#define SU_GENERAL_RELEASE              @"SoftwareUpdateGeneralRelease"

#define SU_STATUS                       @"SoftwareUpdateStatus"
#define SU_STATUS_UNKNOWN               0
#define SU_STATUS_CHECKING              1
#define SU_STATUS_SUCCESS               2
#define SU_STATUS_ERROR                 3

#define SU_LOCALIZED_SCHEDULED          NSLocalizedStringFromTable(@"Next scheduled: %@", @"DSShared", @"Update next scheduled")
#define SU_LOCALIZED_LAST_CHECK         NSLocalizedStringFromTable(@"Last Check:", @"DSShared", @"Update status title for success")
#define SU_LOCALIZED_LAST_ATTEMPT       NSLocalizedStringFromTable(@"Last Attempt:", @"DSShared", @"Update status title for error")
#define SU_LOCALIZED_STATUS             NSLocalizedStringFromTable(@"Status:", @"DSShared", @"Update status title for checking")
#define SU_LOCALIZED_WELCOME            NSLocalizedStringFromTable(@"Welcome!  Please check for an update.", @"DSShared", @"Update never run status")

#define SU_USER_PREFERENCE_KEYS         [NSArray arrayWithObjects:SU_MODE, SU_FREQUENCY, SU_LEVEL, nil]
#define SU_ALL_PREFERENCE_KEYS          [NSArray arrayWithObjects:SU_MODE, SU_FREQUENCY, SU_LEVEL, SU_DEFAULT_LEVEL, SU_LAST_CHECK, SU_LAST_ATTEMPT, SU_LAST_MESSAGE, SU_GENERAL_RELEASE, SU_STATUS, nil]


