//
//  DSSoundController.h
//  Shared classes
//
//  Created by David Sinclair on Fri May 06 2005.
//  Copyright (c) 2005 Dejal Systems, LLC. All rights reserved.
//


#import "DSSoundData.h"


@interface DSSoundController : NSObject
{
    DSSoundData *_soundData;
    NSPopUpButton *_popup;
    NSTextField *_pathField;
    NSButton *_playButton;
    int _baseItemCount;
}

+ (id)controllerWithDictionary:(NSDictionary *)settings
                         popup:(NSPopUpButton *)popup 
                     pathField:(NSTextField *)pathField
                    playButton:(NSButton *)playButton;

- (id)initWithDictionary:(NSDictionary *)settings
                   popup:(NSPopUpButton *)popup
               pathField:(NSTextField *)pathField
              playButton:(NSButton *)playButton;

- (void)reloadWithDictionary:(NSDictionary *)settings;
- (void)reload;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACTION METHODS
// ----------------------------------------------------------------------------------------

- (void)changeModeForWindow:(NSWindow *)parentWindow;
- (void)playStop;
- (void)pathChanged;
- (void)openSoundForWindow:(NSWindow *)parentWindow;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSDictionary *)dictionary;

- (DSSoundData *)soundData;
- (void)setSoundData:(DSSoundData *)value;

- (NSPopUpButton *)popup;
- (void)setPopup:(NSPopUpButton *)value;

- (NSTextField *)pathField;
- (void)setPathField:(NSTextField *)value;

- (NSButton *)playButton;
- (void)setPlayButton:(NSButton *)value;

- (int)baseItemCount;
- (void)setBaseItemCount:(int)value;

@end
