//
//  DSToolbarController.h
//  Shared classes
//
//  Created by David Sinclair on Sat Feb 21 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//


@interface DSToolbarController : NSObject
{
    NSToolbar *_toolbar;
    NSMutableArray *_toolbarItems;
    
    IBOutlet id editorWindowController;
    IBOutlet NSWindow *window;
}

// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark OVERRIDE METHODS
// ----------------------------------------------------------------------------------------

- (void)addToolbarItems;

- (NSString *)identifier;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark UTILITY METHODS
// ----------------------------------------------------------------------------------------

- (BOOL)toolbarIsVisible;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark NSTOOLBAR DELEGATE METHODS
// ----------------------------------------------------------------------------------------

- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar
     itemForItemIdentifier:(NSString *)itemIdentifier
 willBeInsertedIntoToolbar:(BOOL)flag;

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar *)toolbar;

- (void)toolbarWillAddItem:(NSNotification *)notification;
- (void)toolbarDidRemoveItem:(NSNotification *)notification;

- (IBAction)showHideToolbar:(id)sender;
- (IBAction)customizeToolbar:(id)sender;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSToolbar *)toolbar;
- (void)setToolbar:(NSToolbar *)value;

- (NSMutableArray *)toolbarItems;
- (void)setToolbarItems:(NSMutableArray *)value;

@end
