//
//  DSDelegateData.h
//  Shared classes
//
//  Created by David Sinclair on 2006-02-12.
//  Copyright 2006 - 2007 Dejal Systems, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface DSDelegateData : NSObject
{
    id _delegate;
}

- (void)informDelegateUsingSignature:(NSString *)signature;
- (void)informDelegateUsingSignature:(NSString *)signature withObject:(id)object;
- (void)informDelegateUsingSignature:(NSString *)signature withArguments:(NSArray *)arguments;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (id)delegate;
- (void)setDelegate:(id)value;

@end


// ----------------------------------------------------------------------------------------
#pragma mark -
// ----------------------------------------------------------------------------------------


@interface NSObject (DSDelegateDataInformalProtocol)

/*
 delegateData:sentDelegateMessage:
 
 Informs the delegate that the specified delegate message and object was sent.  If implemented, this is invoked after every other delegate message.  Useful for debugging.
*/

- (void)delegateData:(id)delegateData sentDelegateMessage:(NSDictionary *)parameters;

@end

