//
//  DSImageData.h
//  Shared classes
//
//  Created by David Sinclair on Tue Jan 20 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//



@interface DSImageData : NSObject
{
    NSMutableDictionary *_cache;
    NSString *_userPath;
}

+ (id)sharedImageData;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark IMAGE HANDLING METHODS
// ----------------------------------------------------------------------------------------

- (NSImage *)imageNamed:(NSString *)name forDomain:(NSString *)domain delegate:(id)delegate;
- (NSImage *)imageNamed:(NSString *)name forDomain:(NSString *)domain;
- (NSImage *)imageNamed:(NSString *)name forDomain:(NSString *)domain ofSize:(int)size;
- (NSImage *)imageNamed:(NSString *)name forDomain:(NSString *)domain fromPath:(NSString *)path delegate:(id)delegate;
- (NSImage *)imageNamed:(NSString *)name forDomain:(NSString *)domain fromPath:(NSString *)path;

- (void)setImage:(NSImage *)image forDomain:(NSString *)domain withName:(NSString *)name persistent:(BOOL)persistent delegate:(id)delegate;
- (void)setImage:(NSImage *)image forDomain:(NSString *)domain withName:(NSString *)name persistent:(BOOL)persistent;
- (void)setImage:(NSImage *)image forDomain:(NSString *)domain withName:(NSString *)name size:(int)size persistent:(BOOL)persistent;

- (void)removeImageForDomain:(NSString *)domain withName:(NSString *)name persistent:(BOOL)persistent;

- (NSString *)extensionForDomain:(NSString *)domain delegate:(id)delegate;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark DELEGATE METHODS
// ----------------------------------------------------------------------------------------

- (NSString *)extensionForImageDomain:(NSString *)domain;

- (NSData *)imageDomain:(NSString *)domain name:(NSString *)name dataForReadingData:(NSData *)data;
- (NSData *)imageDomain:(NSString *)domain name:(NSString *)name dataForWritingData:(NSData *)data;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSMutableDictionary *)cache;
- (void)setCache:(NSMutableDictionary *)value;

- (NSString *)userPath;
- (void)setUserPath:(NSString *)value;

@end
