//
//  DSIntervalData.h
//  Shared classes
//
//  Created by David Sinclair on 2007-04-05.
//  Copyright 2007-2008 Dejal Systems, LLC. All rights reserved.
//
//  See also DSDateData.
//

#import <Cocoa/Cocoa.h>


@interface DSIntervalData : NSObject <NSCopying>
{
    BOOL _usingRange;
    NSInteger _firstAmount;
    NSInteger _secondAmount;
    NSInteger _units;
    NSInteger _mode;
}

@property BOOL usingRange;
@property NSInteger firstAmount;
@property NSInteger secondAmount;
@property NSInteger amount;
@property NSInteger units;
@property NSInteger mode;
@property(readonly) NSTimeInterval amountTimeInterval;
@property(readonly) NSTimeInterval firstTimeInterval;
@property(readonly) NSTimeInterval secondTimeInterval;
@property(readonly) NSTimeInterval rangeDifferenceInterval;
@property(readonly) NSTimeInterval unitsTimeInterval;

+ (id)intervalWithAmount:(NSInteger)amount units:(NSInteger)units;
+ (id)intervalWithAmount:(NSInteger)amount units:(NSInteger)units mode:(NSInteger)mode;
+ (id)intervalWithRangeFirstAmount:(NSInteger)firstAmount secondAmount:(NSInteger)secondAmount units:(NSInteger)units;

+ (id)intervalWithDictionary:(NSDictionary *)dict;

- (id)initWithRange:(BOOL)usingRange firstAmount:(NSInteger)firstAmount secondAmount:(NSInteger)secondAmount units:(NSInteger)units mode:(NSInteger)mode;

- (NSDictionary *)dictionary;

- (NSTimeInterval)amountTimeInterval;
- (NSTimeInterval)firstTimeInterval;
- (NSTimeInterval)secondTimeInterval;
- (NSTimeInterval)rangeDifferenceInterval;
- (NSTimeInterval)unitsTimeInterval;

- (NSInteger)amount;
- (void)setAmount:(NSInteger)amount;

- (NSString *)amountWithBriefUnitsName;
- (NSString *)amountWithFullUnitsName;

- (NSString *)briefUnitsName;
- (NSString *)fullUnitsName;

@end

