//
//  DSKeyedAccessorData.h
//  Shared classes
//
//  Created by David Sinclair on Fri Feb 20 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//



@interface DSKeyedAccessorData : NSObject <NSCopying>
{
    NSMutableDictionary *_dictionary;
}

- (id)initWithDictionary:(NSDictionary *)dict;

- (id)copyWithZone:(NSZone *)zone;

- (NSDictionary *)dictionary;
- (NSMutableDictionary *)mutableDictionary;
- (void)setDictionary:(NSDictionary *)value;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark VERSIONING METHODS
// ----------------------------------------------------------------------------------------

- (int)dataVersion;
- (void)setDataVersion:(int)value;

- (int)dataFormat;
- (void)setDataFormat:(int)value;

- (int)currentVersion;
- (int)currentFormat;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (void)removeAllObjects;

- (BOOL)boolForKey:(NSString *)key defaultValue:(BOOL)defaultValue;
- (void)setBool:(BOOL)value forKey:(NSString *)key;

- (int)integerForKey:(NSString *)key defaultValue:(int)defaultValue;
- (void)setInteger:(int)value forKey:(NSString *)key;

- (float)floatForKey:(NSString *)key defaultValue:(float)defaultValue;
- (void)setFloat:(float)value forKey:(NSString *)key;

- (NSNumber *)numberForKey:(NSNumber *)key defaultValue:(NSNumber *)defaultValue;
- (void)setNumber:(NSNumber *)value forKey:(NSString *)key;

- (NSString *)stringForKey:(NSString *)key defaultValue:(NSString *)defaultValue;
- (void)setString:(NSString *)value forKey:(NSString *)key;

- (NSMutableArray *)arrayForKey:(NSString *)key defaultValue:(NSArray *)defaultValue;
- (void)setArray:(NSArray *)value forKey:(NSString *)key;

- (NSMutableDictionary *)dictionaryForKey:(NSString *)key defaultValue:(NSDictionary *)defaultValue;
- (void)setDictionary:(NSDictionary *)value forKey:(NSString *)key;

- (id)objectForKey:(NSString *)key defaultValue:(id)defaultValue;
- (void)setObject:(id)value forKey:(NSString *)key;

- (id)keyedAccessorForKey:(NSString *)key class:(Class)class;
- (void)setKeyedAccessor:(id)value forKey:(NSString *)key;

@end
