//
//  DSKeyedCollectionData.h
//  Shared classes
//
//  Created by David Sinclair on Mon Feb 09 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//


@interface DSKeyedCollectionData : NSObject
{
    NSMutableDictionary *_collection;
}

+ (id)collection;
+ (id)collectionWithDictionary:(NSDictionary *)dict forClass:(Class)class;

- (id)initWithDictionary:(NSDictionary *)dict forClass:(Class)class;

- (NSDictionary *)dictionary;
- (NSMutableDictionary *)mutableDictionary;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ADD/REMOVE METHODS
// ----------------------------------------------------------------------------------------

- (void)setRecord:(id)newRecord forIdentifier:(NSString *)identifier;
- (void)removeRecordForIdentifier:(NSString *)identifier;
- (void)removeRecord:(id)oldRecord;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark CONTENTS METHODS
// ----------------------------------------------------------------------------------------

- (NSString *)identifierForRecord:(id)record;
- (id)recordForIdentifier:(NSString *)identifier;

- (NSArray *)identifiersForRecords:(NSArray *)records;
- (NSArray *)recordsForIdentifiers:(NSArray *)identifiers;

- (NSArray *)allIdentifiers;
- (NSArray *)allRecords;

- (NSEnumerator *)identifierEnumerator;
- (NSEnumerator *)recordEnumerator;

- (int)count;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSMutableDictionary *)collection;
- (void)setCollection:(NSMutableDictionary *)dict;

- (NSString *)description;

@end
