//
//  DSKeyedRecordData.h
//  Shared classes
//
//  Created by David Sinclair on Mon Feb 09 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//


@interface DSKeyedRecordData : NSObject
{
    NSString *_identifier;
    NSString *_name;
    NSDate *_createdDate;
    NSDate *_modifiedDate;
    NSDate *_viewedDate;
    NSString *_createdBy;
    NSString *_modifiedBy;
    NSString *_viewedBy;
    NSMutableDictionary *_savedData;
}

+ (id)record;
+ (id)recordWithDictionary:(NSDictionary *)dict;

- (id)initWithDictionary:(NSDictionary *)dict;

- (NSDictionary *)dictionary;
- (NSMutableDictionary *)mutableDictionary;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ADD/REMOVE METHODS
// ----------------------------------------------------------------------------------------

- (void)modified;
- (void)viewed;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSString *)identifier;
- (void)setIdentifier:(NSString *)value;

- (NSString *)name;
- (void)setName:(NSString *)value;

- (NSDate *)createdDate;
- (void)setCreatedDate:(NSDate *)value;

- (NSDate *)modifiedDate;
- (void)setModifiedDate:(NSDate *)value;

- (NSDate *)viewedDate;
- (void)setViewedDate:(NSDate *)value;

- (NSString *)createdBy;
- (void)setCreatedBy:(NSString *)value;

- (NSString *)modifiedBy;
- (void)setModifiedBy:(NSString *)value;

- (NSString *)viewedBy;
- (void)setViewedBy:(NSString *)value;

- (NSDictionary *)savedData;
- (void)setSavedData:(NSDictionary *)value;

- (NSComparisonResult)compare:(id)record;

- (NSString *)searchableString;
- (NSString *)description;

@end
