/*
 *  DSResourceForkData.h
 *  Shared
 *
 *  Created by nathan on Wed Dec 05 2001.
 *  Co-opted and modified by David Sinclair on Thu Mar 17 2003.
 *  Copyright (c) 2001 Nathan Day. All rights reserved.
 */

#import <Foundation/Foundation.h>
#import <Carbon/Carbon.h>

@interface DSResourceForkData : NSObject
{
    short fileReference;
}

+ (NSData *)resourceForkContentsAtPath:(NSString *)path;
+ (BOOL)createResourceForkAtPath:(NSString *)path contents:(NSData *)contents
                      attributes:(NSDictionary *)attributes;

+ (id)resourceForkForReadingAtPath:(NSString *)aPath;
+ (id)resourceForkForWritingAtPath:(NSString *)aPath;

- (id)initForReadingAtPath:(NSString *)aPath;
- (id)initForWritingAtPath:(NSString *)aPath;

- (id)initForPermission:(char)aPermission atPath:(NSString *)aPath;

+ (long)resourceForkSizeAtPath:(NSString *)path;

- (BOOL)addData:(NSData *)aData type:(ResType)aType withID:(short)anID name:(NSString *)aName;
- (NSData *)dataForType:(ResType)aType withID:(short)anID;

/*
 * string methods handle converting between an NSString and a Pascal string
 * as stored in a resource fork
*/
- (BOOL)addString:(NSString *)aString type:(ResType)aType withID:(short)anID name:(NSString *)aName;
- (NSString *)stringForType:(ResType)aType withID:(short)anID;

- (BOOL)removeType:(ResType)aType withID:(short)anID;

@end
