//
//  DSSearchData.h
//  Shared classes
//
//  Created by David Sinclair on Sat Dec 06 2003.
//  Copyright (c) 2003 - 2004 Dejal Systems, LLC. All rights reserved.
//


@interface DSSearchData : NSObject
{
    DSSearchData *_root;
    
    NSMutableData *_searchKitBuffer;
    SKIndexRef _searchKitIndex;
    SKDocumentRef _searchKitDocument;
}

+ (id)searchDataWithBuffer:(NSMutableData *)buffer;
+ (id)searchDataWithPath:(NSString *)path;
+ (id)searchDataWithIdentifier:(NSString *)identifier string:(NSString *)searchableString parentSearchData:(id)parentSearchData;

- (id)initWithBuffer:(NSMutableData *)buffer;
- (id)initWithPath:(NSString *)path;
- (id)initWithIdentifier:(NSString *)identifier string:(NSString *)searchableString parentSearchData:(id)parentSearchData;

- (void)flush;

- (void)remove;

- (void)updateWithString:(NSString *)searchableString;

- (NSArray *)searchForString:(NSString *)searchString;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (id)root;
- (void)setRoot:(id)value;

- (NSMutableData *)searchKitBuffer;
- (void)setSearchKitBuffer:(NSMutableData *)value;

- (SKIndexRef)searchKitIndex;
- (void)setSearchKitIndex:(SKIndexRef)value;

- (SKDocumentRef)searchKitDocument;
- (void)setSearchKitDocument:(SKDocumentRef)value;

@end
