//
//  DSSortCriteria.m
//  Shared classes
//
//  Created by David Sinclair on Sat Mar 20 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//

#import "DSSortCriteriaData.h"
#import "DSSharedDefines.h"


@implementation DSSortCriteriaData

/*
 criteria
 
 Creates new default criteria.
 
 Written by DJS 2004-03.
*/

+ (id)criteria
{
    return [[[self alloc] init] autorelease];
}

/*
 criteriaWithDictionary:
 
 Creates new criteria based on the specified dictionary.
 
 Written by DJS 2004-03.
*/

+ (id)criteriaWithDictionary:(NSDictionary *)dict
{
    return [[[self alloc] initWithDictionary:dict] autorelease];
}


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (BOOL)descending
{
    return [self boolForKey:@"DSSortDescending" defaultValue:NO];
}

- (void)setDescending:(BOOL)value
{
    [self setBool:value forKey:@"DSSortDescending"];
}

@end
