//
//  DSSortedData.h
//  Shared classes
//
//  Created by David Sinclair on Mon Feb 09 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//


@interface DSSortedData : NSObject
{
    NSMutableArray *_sortedArray;
    id _criteria;
}

+ (id)sortedData;
+ (id)sortedDataWithArray:(NSArray *)array criteria:(id)criteria;

- (id)initWithArray:(NSArray *)array criteria:(id)criteria;

- (Class)sortCriteriaClass;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark SORTING METHODS
// ----------------------------------------------------------------------------------------

- (BOOL)sort;

- (BOOL)reverseIfNeeded;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark CONTENTS METHODS
// ----------------------------------------------------------------------------------------

- (BOOL)isValidIndex:(int)index;

- (id)objectAtIndex:(int)index;
- (int)indexOfObject:(id)object;

- (NSEnumerator *)objectEnumerator;

- (int)count;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSMutableArray *)sortedArray;
- (void)setSortedArray:(NSArray *)value;

- (id)criteria;
- (void)setCriteria:(id)value;

@end
