//
//  DSSoundData.h
//  Shared classes
//
//  Created by David Sinclair on Fri May 06 2005.
//  Copyright (c) 2005 Dejal Systems, LLC. All rights reserved.
//


@interface DSSoundData : NSObject
{
    int _mode;
    NSString *_otherPath;
    NSString *_currentPath;
    NSSound *_currentSound;
}

+ (id)dataWithDictionary:(NSDictionary *)settings;
+ (id)playWithDictionary:(NSDictionary *)settings;

- (id)initWithDictionary:(NSDictionary *)settings;

- (BOOL)isPlaying;
- (void)playStop;
- (void)play;
- (void)stop;

- (void)playSoundAtPath:(NSString *)path;
- (void)sound:(NSSound *)sound didFinishPlaying:(BOOL)aBool;

- (void)notifyPlayStop:(BOOL)isPlaying;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSDictionary *)dictionary;
- (void)reloadWithDictionary:(NSDictionary *)settings;

- (int)mode;
- (void)setMode:(int)value;

- (NSString *)otherPath;
- (void)setOtherPath:(NSString *)value;

- (NSString *)currentPath;
- (void)setCurrentPath:(NSString *)value;

- (NSSound *)currentSound;
- (void)setCurrentSound:(NSSound *)value;

@end
