//
//  DSSpeechData.h
//  Shared
//
//  Created by David Sinclair on Sat Nov 30 2002.
//

#import <Foundation/Foundation.h>
#import <Carbon/Carbon.h>


@interface DSSpeechData : NSObject
{
    SpeechChannel _speechChannel;
    id _delegate;
    NSPort *_port;

    BOOL _usePort;
    unsigned int _reserved1;
    unsigned int _reserved2;
}

+ (NSArray *)voiceNames;

- (float)rate;
- (void)setRate:(float)rate;

- (float)pitch;
- (void)setPitch:(float)pitch;

- (float)inflection;
- (void)setInflection:(float)inflection;

- (float)volume;
- (void)setVolume:(float)volume;

- (int)voice;
- (void)setVoice:(int)index;
- (void)setVoiceFromName:(NSString *)name;

- (void)reset;

- (void)speakText:(NSString *)text;
- (void)speakText:(NSString *)text afterSilentInterval:(NSTimeInterval)interval;
- (void)stopSpeaking;

- (id)delegate;
- (void)setDelegate:(id)delegate;

@property (getter=usesPort) BOOL _usePort;
@property (setter=setReserved1:) unsigned int _reserved1;
@property (retain,getter=port) NSPort *_port;
@property (setter=setReserved2:) unsigned int _reserved2;
@property SpeechChannel _speechChannel;
@property (assign,getter=delegate,setter=setDelegate:) id _delegate;
@end


@interface NSObject (SpeechDataDelegate)

- (void)didFinishSpeaking:(DSSpeechData *)speaker;
- (void)willSpeakWord:(DSSpeechData *)speaker at:(int)where length:(int)length;

@end
