/* DSGraphController */

#import <Cocoa/Cocoa.h>


@class SM2DGraphView;


@interface DSGraphController : NSWindowController
{
    NSMutableArray *_groupNamesArray;
    NSMutableArray *_groupColorsArray;
    NSMutableArray *_valueLabelsArray;
    NSMutableArray *_groupedValuesArray;
    NSMutableArray *_groupedLinesArray;

    float _highestCount;
    
    IBOutlet SM2DGraphView *graphView;
    IBOutlet NSButton *toggleDrawerButton;
    IBOutlet NSDrawer *legendDrawer;
    IBOutlet NSTableView *legendTableView;
}

+ (id)graph;

- (BOOL)addGroupObject:(id)groupObject withCountObject:(id)countObject;

- (void)setTitle:(NSString *)title withCountName:(NSString *)countName groupName:(NSString *)groupName;
- (void)displayWindow;

- (void)simplify;
- (void)setupColors;

- (IBAction)openLegendDrawer:(id)sender;
- (IBAction)closeLegendDrawer:(id)sender;
- (IBAction)toggleLegendDrawer:(id)sender;

@end
