/* DSGraphTableSheetController */

#import <Cocoa/Cocoa.h>

@interface DSGraphTableSheetController : NSWindowController
{
    id _tableController;
    NSTableView *_tableView;
    NSMutableArray *_lines;
    NSString *_countPref;
    NSString *_groupPref;

    IBOutlet NSPopUpButton *countPopup;
    IBOutlet NSPopUpButton *groupPopup;
    IBOutlet NSTextField *titleStat;
}

+ (id)showGraphTableSheetWithTitle:(NSString *)title forController:(id)tableController
                          ofWindow:(NSWindow *)tableWindow withTableView:(NSTableView *)tableView
                         countPref:(NSString *)countPref groupPref:(NSString *)groupPref;

- (id)initGraphTableSheetWithTitle:(NSString *)title forController:(id)tableController
                          ofWindow:(NSWindow *)tableWindow withTableView:(NSTableView *)tableView
                         countPref:(NSString *)countPref groupPref:(NSString *)groupPref;

- (void)showAsSheetOnWindow:(NSWindow *)tableWindow;

- (IBAction)cancelButtonHit:(id)sender;
- (IBAction)graphButtonHit:(id)sender;
- (IBAction)countPopupHit:(id)sender;
- (IBAction)groupPopupHit:(id)sender;

- (id)tableController;
- (void)setTableController:(id)value;

- (NSTableView *)tableView;
- (void)setTableView:(NSTableView *)value;

- (NSMutableArray *)lines;
- (void)setLines:(NSMutableArray *)value;

- (NSString *)countPref;
- (void)setCountPref:(NSString *)value;

- (NSString *)groupPref;
- (void)setGroupPref:(NSString *)value;

@end
