//
//  DSPopupClusterHandler.h
//  Shared classes
//
//  Created by David Sinclair on Thu Jan 22 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//

#import "DSPopupSingleHandler.h"


/*
 DSPopupClusterHandler
 
 This class is an abstract superclass for a DSViewsListView handler.  It should be used if there are multiple container views in multiple Nib files.  If there are multiple container views in one Nib file, use DSPopupHandler instead.  If there is only one container view in one Nib file, use DSPopupSingleHandler instead.  Do not change this class in a way that will break existing subclasses; any changes should probably go in a subclass instead.
*/

@interface DSPopupClusterHandler : DSPopupSingleHandler
{
    NSString *_kind;
}

+ (Class)clusterPublicClass;
- (Class)clusterPublicClass;
+ (Class)clusterSubclassForKind:(NSString *)kind;
- (int)modeForKind:(NSString *)kind;
- (NSString *)kindForMode:(int)mode;

- (void)didAddHandler:(id)newHandler;
- (void)didAddFromHandler:(id)otherHandler;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark ACCESSOR METHODS
// ----------------------------------------------------------------------------------------

- (NSString *)kind;
- (void)setKind:(NSString *)value;

@end
