//
//  DSPopupSingleHandler.h
//  Shared classes
//
//  Created by David Sinclair on Mon Feb 16 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//

#import "DSPopupHandler.h"


/*
 DSPopupSingleHandler
 
 This class is an abstract superclass for a DSViewsListView handler.  It should be used if there is only one container view in one Nib file.  If there are multiple container views in one Nib file, use DSPopupHandler instead.  If there are multiple container views in multiple Nib files, use DSPopupClusterHandler instead.  Do not change this class in a way that will break existing subclasses; any changes should probably go in a subclass instead.
*/

@interface DSPopupSingleHandler : DSPopupHandler
{
    IBOutlet NSView *containerView;
    IBOutlet NSPopUpButton *modePopup;
    IBOutlet NSButton *addButton;
    IBOutlet NSButton *removeButton;
}

// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark CONFIGURATION METHODS
// ----------------------------------------------------------------------------------------

- (void)completeInitializationWithSettings:(NSDictionary *)settings;
- (NSString *)nibName;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark UTILITY METHODS
// ----------------------------------------------------------------------------------------

- (void)buildModePopup;

@end
