//
//  DSPluginManager.h
//  Shared classes
//
//  Created by David Sinclair on Thu Jun 19 2003.
//  Copyright (c) 2003 - 2007 Dejal Systems, LLC. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "DSPluginProtocol.h"


@interface DSPluginManager : NSObject
{
    NSMutableArray *_classes;		// An array of all plug-in classes
}

+ (id)sharedPluginManager;

- (NSEnumerator *)classEnumerator;

- (id)pluginForIdentifier:(NSString *)identifier forType:(NSString *)type protocol:(Protocol *)protocol withSettings:(NSMutableDictionary *)settings orDefaultIdentifier:(NSString *)defaultIdentifier orFirst:(BOOL)firstIfNotFound;

- (Class)classForIdentifier:(NSString *)identifier withProtocol:(Protocol *)protocol orFirst:(BOOL)firstIfNotFound;
- (Class)classForIdentifier:(NSString *)identifier withProtocol:(Protocol *)protocol orDefaultIdentifier:(NSString *)defaultIdentifier orFirst:(BOOL)firstIfNotFound;

- (NSMutableArray *)classes;

@end
