//
//  DSProgressCell.m
//  Shared classes
//
//  Created by David Sinclair on Thu Dec 09 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//

#import "DSProgressCell.h"


@implementation DSProgressCell

- (id)initProgressCellWithAltImage:(NSImage *)image
{
    self = [super initImageCell:image];
    
    [self setProgressController:nil];
    
    return self;
}

- (void)dealloc
{
    [self setProgressController:nil];
    
    [super dealloc];
}

- (DSProgressCellController *)progressController
{
    return _progressController;
}

- (void)setProgressController:(DSProgressCellController *)controller
{
    // Weak reference:
    _progressController = controller;
}

- (void)drawWithFrame:(NSRect)cellFrame inView:(NSView *)controlView
{
    NSImage *image = [self image];
    BOOL animating = [[self progressController] isAnimating];
    
    if (animating)
        [self setImage:[[[NSImage alloc] init] autorelease]];
    
    [super drawWithFrame:cellFrame inView:controlView];
    
    if (animating)
        [self setImage:image];
    
    NSView *view = [[self progressController] progressView];
    
    if (!view || !animating)
        return;
    
    [view setFrame:cellFrame];
    
    if ([view superview] != controlView)
    {
        [controlView addSubview:view];
    }
}

@end
