/* DSProgressCellController */


@interface DSProgressCellController : NSObject
{
    IBOutlet NSView *progressView;
    IBOutlet NSProgressIndicator *progressIndicator;
    
    BOOL _isAnimating;
}

+ (id)controller;

- (NSView *)progressView;
- (NSProgressIndicator *)progressIndicator;

- (BOOL)isAnimating;
- (void)setAnimating:(BOOL)value;

- (void)toggleAnimation:(BOOL)value;

- (void)startAnimation;
- (void)stopAnimation;

@end


// ----------------------------------------------------------------------------------------
#pragma mark -
// ----------------------------------------------------------------------------------------


@interface NSTableView (DSProgressExtensions)

- (void)reloadDataAndProgress;

- (void)setProgressController:(DSProgressCellController *)progressController forCell:(id)cell;

@end
