/* ProgressViewController */

#import <Cocoa/Cocoa.h>
#import "DSProgressData.h"


@interface DSProgressViewController : NSObject
{
    IBOutlet NSView *alertContainerView;
    IBOutlet NSImageView *alertIcon;
    IBOutlet NSTextField *alertMessageStat;
    IBOutlet NSButton *alertOKButton;
    IBOutlet NSTextField *alertOperationStat;
    IBOutlet NSProgressIndicator *alertProgressBar;
    
    IBOutlet NSView *collapsedContainerView;
    IBOutlet NSButton *collapsedDisclosureButton;
    IBOutlet NSProgressIndicator *collapsedProgressBar;
    IBOutlet NSTextField *collapsedTimeStat;
    IBOutlet NSButton *collapsedStopButton;
    
    IBOutlet NSView *normalContainerView;
    IBOutlet NSButton *normalDisclosureButton;
    IBOutlet NSProgressIndicator *normalProgressBar;
    IBOutlet NSTextField *normalCurrentItemStat;
    IBOutlet NSTextField *normalSizeStat;
    IBOutlet NSTextField *normalTimeStat;
    IBOutlet NSButton *normalStopButton;

    DSProgressData *_progressData;
    NSView *_containerView;
    NSDate *_startDate;
}

- (BOOL)adjustContentsViewChanged;


- (IBAction)alertOKButtonHit:(id)sender;

- (IBAction)collapsedDisclosureButtonHit:(id)sender;
- (IBAction)collapsedStopButtonHit:(id)sender;

- (IBAction)normalDisclosureButtonHit:(id)sender;
- (IBAction)normalStopButtonHit:(id)sender;


- (DSProgressData *)progressData;
- (void)setProgressData:(DSProgressData *)value;

- (NSView *)containerView;
- (void)setContainerView:(NSView *)value;

- (NSDate *)startDate;
- (void)setStartDate:(NSDate *)value;

@end
