/* ProgressWindowController */

#import <Cocoa/Cocoa.h>
#import "DSProgressData.h"

@class DSProgressViewController;
@class DSProgressData;


@interface DSProgressWindowController : NSWindowController
{
    NSMutableArray *_progressViewArray;
    
    IBOutlet NSScrollView *scrollView;
    IBOutlet NSTextField *productStat;
}

+ (id)sharedProgressWindowController;

+ (DSProgressData *)progressWindowTitle:(NSString *)windowTitle
                              operation:(NSString *)operation
                             sourceName:(NSString *)sourceName
                        destinationName:(NSString *)destinationName
                            buttonTitle:(NSString *)buttonTitle;

- (DSProgressData *)addProgressWindowTitle:(NSString *)windowTitle
                                 operation:(NSString *)operation
                                sourceName:(NSString *)sourceName
                           destinationName:(NSString *)destinationName
                               buttonTitle:(NSString *)buttonTitle;

- (void)cycle;

- (void)changeViewFrom:(NSView *)oldView forProgressView:(DSProgressViewController *)progressView;

- (void)maintainWindowTitle;
- (void)maintainProductStat;

- (IBAction)productStatHit:(id)sender;

- (NSMutableArray *)progressViewArray;
- (void)setProgressViewArray:(NSMutableArray *)value;

@end
