#import <unistd.h>
#import "DSSplashController.h"
#import "DSSplashView.h"
#import "DSLicenseController.h"
#import "DSSharedController.h"
#import "MainDefines.h"


@implementation DSSplashController

id sharedSplashController;

+ (id)sharedSplashController
{
    if (SHOW_SPLASH)
    {
        if (!sharedSplashController)
        {
            sharedSplashController = [[self alloc] init];
        }
    }
    else
        sharedSplashController = nil;
    
    return sharedSplashController;
}

/*
- (void)dealloc
{
    [lastProgress release];

    [super dealloc];
}
*/


- (void)showSplash
{
//    NSLog(@"showSplash before loadNibNamed::");		//  log
    
    [NSBundle loadNibNamed:@"Splash" owner:self];
    
//    NSLog(@"showSplash before clearing stat");		//  log
    
    [progressStat setStringValue:@""];
//    lastProgress = @"";
//    progressCount = 0;

//    NSLog(@"showSplash before showWindow:");		//  log
    
//    NSLog(@"showSplash before fadeIn::::");		//  log
    
//    [[self window] fadeIn:YES forInterval:0.5 target:self selector:@selector(duringAnimation:) withObject:nil];

//    NSLog(@"showSplash before imageNamed:");		//  log
    
    NSImage *splashBackground = [NSImage imageNamed:@"SplashBackground"];
//    NSImage *splashTitle = [NSImage imageNamed:@"SplashTitle"];

//    NSLog(@"showSplash before updateImage:::");		//  log
    
    NSString *splashString = [[DSLicenseController sharedLicenseController] splashString];
    NSArray *splashArray = [splashString componentsSeparatedByString:@"\n"];
    NSString *splashFirstString = [splashArray count] > 0 ? [splashArray objectAtIndex:0] : @"Can't find license info!";
    NSString *splashSecondString = [splashArray count] > 1 ? [splashArray objectAtIndex:1] : @"";
    
    [self updateImage:splashBackground offsetHoriz:20 offsetVert:130
           withString:PRODUCT_VERSION
                 font:[NSFont fontWithName:@"Trebuchet MS Bold" size:18] color:[NSColor whiteColor]];
    [self updateImage:splashBackground offsetHoriz:20 offsetVert:160
           withString:[LOCALIZEDINFODICT objectForKey:@"NSHumanReadableCopyright"]
                 font:[NSFont fontWithName:@"Trebuchet MS" size:13] color:[NSColor whiteColor]];
    [self updateImage:splashBackground offsetHoriz:20 offsetVert:185
           withString:splashFirstString
                 font:[NSFont fontWithName:@"Trebuchet MS Bold" size:14] color:[NSColor redColor]];
    [self updateImage:splashBackground offsetHoriz:20 offsetVert:203
           withString:splashSecondString
                 font:[NSFont fontWithName:@"Trebuchet MS Bold" size:14] color:[NSColor redColor]];
    
    [splashView setBackgroundImage:splashBackground];
    
    [self showWindow:[self window]];
    [[self window] fadeIn:YES forInterval:0.5 target:self selector:@selector(duringAnimation:) withObject:nil];

//    NSLog(@"showSplash before dissolveFromImage:::");		//  log
    
//    [self dissolveFromImage:splashBackground toImage:splashTitle forInterval:0.5];
    
//    NSLog(@"showSplash at end");		//  log
    
}

- (void)removeSplash
{
    [progressStat setStringValue:@""];
    
    [[self window] fadeIn:NO forInterval:0.5 target:self selector:@selector(duringAnimation:) withObject:nil];
    
    [[self window] close];

    [self autorelease];
    sharedSplashController = nil;
}

- (void)duringAnimation:(id)object
{
    [[DSSharedController mainController] animateDockIcon];
}

- (void)dissolveFromImage:(NSImage *)source toImage:(NSImage *)dest forInterval:(NSTimeInterval)totalTime
{
    NSImage *combo;
    NSDate *start = [NSDate date];
    NSTimeInterval elapsedTime;
    float alpha;

    do
    {
        elapsedTime = -[start timeIntervalSinceNow];
        alpha = elapsedTime / totalTime;

        if (alpha > 1.0)
            alpha = 1.0;

        combo = [source copy];

//        NSLog(@"combo = %@; alpha = %f", combo, alpha);

        [combo lockFocus];
        [dest dissolveToPoint:NSZeroPoint fraction:alpha];
        [combo unlockFocus];

        [splashView setBackgroundImage:combo];
        [combo release];
        [[self window] display];

        [[DSSharedController mainController] animateDockIcon];
    }
    while (elapsedTime < totalTime);

    [splashView setBackgroundImage:dest];
    [[self window] display];
}

- (void)updateImage:(NSImage *)image offsetHoriz:(int)horiz offsetVert:(int)vert
         withString:(NSString *)string font:(NSFont *)font color:(NSColor *)color
{
    NSMutableDictionary *attrs = [NSMutableDictionary dictionary];
    NSSize stringSize;
    NSPoint textLocation;
    NSLock *lock = [[NSLock alloc] init];

//    NSLog(@"updateImage::: before setting font name: %@", font);		//  log
    
    if (font)
        [attrs setObject:font forKey:NSFontAttributeName];
    else
        NSLog(@"updateImage::: font was nil!");		//  log
    
//    NSLog(@"updateImage::: before setting color: %@", color);		//  log
    
    if (color)
        [attrs setObject:color forKey:NSForegroundColorAttributeName];
//    else
//        NSLog(@"updateImage::: color was nil!");		//  log
    
//    NSLog(@"updateImage::: before other stuff");		//  log
    
    stringSize = [string sizeWithAttributes:attrs];

    while (stringSize.width > ([image size].width - 125))
    {
        string = [[string substringToIndex:[string length] - 5] stringByAppendingString:@"..."];
        stringSize = [string sizeWithAttributes:attrs];
    }

    textLocation = NSMakePoint((([image size].width - horiz - stringSize.width) * 0.5) + horiz,
                               [image size].height - stringSize.height - vert);

    [lock lock];
    [image lockFocus];

    [string drawAtPoint:textLocation withAttributes:attrs];

    [image unlockFocus];
    [lock unlock];
    [lock release];
}

- (void)changeProgress:(NSString *)progress
{
    [progressStat setStringValue:progress];

    if ([[self window] isVisible])
        [[self window] display];
}

/*
- (void)changeProgress:(NSString *)progress
{
    if ([progress isEqualToString:lastProgress])
    {
        progressCount++;
        
        int index;
        
        for (index = 0; index < progressCount; index++)
            progress = [NSString stringWithFormat:@"  %@.", progress];
    }
    else
    {
        [progress retain];
        [lastProgress release];
        lastProgress = progress;
        
        progressCount = 0;
    }
    
    progress = [NSString stringWithFormat:@"      %@...", progress];
//    progress = [progress stringByAppendingString:@"..."];
    
    [progressStat setStringValue:progress];

    if ([[self window] isVisible])
        [[self window] display];
}
*/

@end
