//
//  DSModeTabSupervisor.h
//  Shared classes
//
//  Created by David Sinclair on Wed May 12 2004.
//  Copyright (c) 2004 Dejal Systems, LLC. All rights reserved.
//
//  A "supervisor" is a special kind of controller that manages a particular view object.
//  This is the supervisor for a NSTabView used to switch modes, e.g. between two or more tables.
//

#import "DSSupervisor.h"


@interface DSModeTabSupervisor : DSSupervisor
{
    IBOutlet NSTabView *modeTabView;
}

- (void)setupWithSupervisors:(NSArray *)supervisorArray;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark CONFIGURATION METHODS
// ----------------------------------------------------------------------------------------

- (NSString *)preferenceForSelectedTab;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark UTILITY METHODS
// ----------------------------------------------------------------------------------------

- (id)selectedSupervisor;
- (id)supervisorForIdentifier:(NSString *)identifier;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark NSTABVIEW DELEGATE METHODS
// ----------------------------------------------------------------------------------------

- (void)tabView:(NSTabView *)tabView willSelectTabViewItem:(NSTabViewItem *)tabViewItem;

@end
