//
//  Cipher.m
//  MacJournal
//
//  Created by Dan Schimpf on Fri Feb 15 2002.
//  Copyright (c) 2002 Dan Schimpf. All rights reserved.
//

#import "Cipher.h"

// static const unsigned short int size = sizeof(unsigned long);
// static const unsigned short int doubleSize = sizeof(unsigned long[2]);

@implementation Cipher

// Changed by DJS 2004-01 based on code from MulleCipherBlowfish.m:

+(NSData *)encryptObject:(id <NSCoding>)object withKey:(NSString *)key
{
    NSMutableData *mutableData = [[[NSArchiver archivedDataWithRootObject:object] mutableCopy] autorelease];
    BLOWFISH_CTX ctx;
    unsigned long   lr[ 2];
    unsigned int    i;
    unsigned int    n;
    unsigned int    runs;
    unsigned char   *p;
    unsigned char   *old;
    
    Blowfish_Init(&ctx, (unsigned char *)[key cString], [key cStringLength]);
    
    n = [mutableData length];
    old = p = (void *) [mutableData bytes];
    runs = n / sizeof( lr);
    
    for( i = 0; i < runs; i++)
    {
        Blowfish_Encrypt(&ctx, (unsigned long *) p, (unsigned long *) p + 1);
        
        p += sizeof( lr);
    }
    
/*
    if( n -= runs * sizeof( lr))
    {
        memcpy( lr, p, n);
        Blowfish_Encrypt(&ctx, &lr[ 0], &lr[ 1]);
        //      
        // can't lose those blowfish bytes. proper in place encryption
        // is not possible with blowfish, when the data is not length aligned
        //
        
        [mutableData increaseLengthBy:sizeof( lr) - n];
        p = &((unsigned char *) [mutableData bytes])[ p - old];
        memcpy( p, lr, sizeof( lr));
    }
*/
    
    return mutableData;
}

// Changed by DJS 2004-01 based on code from MulleCipherBlowfish.m:

+(id)decryptObjectWithData:(NSData *)data withKey:(NSString *)key
{
    NSMutableData *mutableData = [[data mutableCopy] autorelease];
    id decryptedObject;
    BLOWFISH_CTX ctx;
    unsigned long   lr[ 2];
    unsigned int    i;
    unsigned int    n;
    unsigned int    runs;
    unsigned char   *p;
    
    Blowfish_Init(&ctx, (unsigned char *)[key cString], [key cStringLength]);

    n = [mutableData length];
    p = (void *) [mutableData bytes];
    runs = n / sizeof( lr);
    
    for( i = 0; i < runs; i++)
    {
        Blowfish_Decrypt(&ctx, (unsigned long *) p, (unsigned long *) p + 1);
        
        p += sizeof( lr);
    }
    
    decryptedObject = [NSUnarchiver unarchiveObjectWithData:mutableData];
    
    return decryptedObject;
}

/*
 +(NSData *)encryptObject:(id <NSCoding>)object withKey:(NSString *)key {
     NSData *data = [NSArchiver archivedDataWithRootObject:object];
     BLOWFISH_CTX ctx;
     unsigned int length = [data length], passes = length/doubleSize;
     unsigned long * bytes;
     unsigned short int i;
     void * position;
     
     if (!data || !key) return nil;
     bytes = malloc(length*sizeof(unsigned long));
     
     [data getBytes:(void *)bytes];
     
     Blowfish_Init(&ctx, (unsigned char *)[key cString], [key cStringLength]);
     
     for (i=0, position=(void *)bytes; i<passes; i++, position+=doubleSize)
         Blowfish_Encrypt(&ctx, position, position+size);
     
     data = [NSData dataWithBytes:bytes length:length];
     
     free(bytes);
     
     return data;
 }
 
 +(id)decryptObjectWithData:(NSData *)data withKey:(NSString *)key {
     id decryptedObject;
     BLOWFISH_CTX ctx;
     unsigned int length = [data length], passes = length/doubleSize;
     unsigned long * bytes;
     unsigned short int i;
     void * position;
     
     if (!data || !key) return nil;
     bytes = malloc(length*sizeof(unsigned long));
     
     [data getBytes:(void *)bytes];
     
     Blowfish_Init(&ctx, (unsigned char *)[key cString], [key cStringLength]);
     
     for (i=0, position=(void *)bytes; i<passes; i++, position+=doubleSize)
         Blowfish_Decrypt(&ctx, position, position+size);
     
     decryptedObject = [NSUnarchiver unarchiveObjectWithData:[NSData dataWithBytes:bytes length:length]];
     
     free(bytes);
     
     //if (!decryptedObject)
     
     return decryptedObject;
 }
*/

+(int)test {
    BLOWFISH_CTX ctx;
    
    return Blowfish_Test(&ctx);
}

@end

NSString * CipherBadKeyException = @"CipherBadKeyException";