//
//  DSTableView.h
//  Shared classes
//
//  Created by David Sinclair on Tue Nov 11 2003.
//  Copyright (c) 2003 - 2007 Dejal Systems, LLC. All rights reserved.
//


// NOTE: may want to merge the DSOutlineView enhancements into here, perhaps sharing the implementation via a private class to avoid code duplication.

// NOTE: This class used to implement source list drawing and column hiding.  This code has been deleted, as these are implemented in 10.5 and later.  See -[NSTableColumn setHidden:] for hiding.


@interface DSTableView : NSTableView
{
    NSPasteboard *_DSDragPasteboard;
    BOOL _DSUsesDragDelete;
}


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark DELETE KEY METHODS
// ----------------------------------------------------------------------------------------

- (void)keyDown:(NSEvent *)theEvent;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark CUSTOM DRAG METHODS
// ----------------------------------------------------------------------------------------

- (NSImage *)dragImageForRowsWithIndexes:(NSIndexSet *)dragRows
                            tableColumns:(NSArray *)tableColumns
                                   event:(NSEvent *)dragEvent
                                  offset:(NSPointPointer)dragImageOffset;


// ----------------------------------------------------------------------------------------
#pragma mark -
#pragma mark DRAG DELETE METHODS
// ----------------------------------------------------------------------------------------

- (NSPasteboard *)dragPasteboard;

- (BOOL)usesDragDelete;
- (void)setUsesDragDelete:(BOOL)value;

@property (assign,getter=dragPasteboard,setter=setDragPasteboard:) NSPasteboard *_DSDragPasteboard;
@property (getter=usesDragDelete,setter=setUsesDragDelete:) BOOL _DSUsesDragDelete;

@end


// ----------------------------------------------------------------------------------------
#pragma mark -
// ----------------------------------------------------------------------------------------


@interface NSObject (DSTableViewDelegate)

- (void)tableView:(DSTableView *)tableView shouldDeleteRowIndexes:(NSIndexSet *)indexes;

- (NSImage *)tableView:(DSTableView *)tableView dragImageForRowsWithIndexes:(NSIndexSet *)dragRows
          tableColumns:(NSArray *)tableColumns event:(NSEvent *)dragEvent offset:(NSPointPointer)dragImageOffset;

@end

