// App-specific stuff used by shared code:

#define PRODUCT_NUMBER_INT              1
#define PRODUCT_NUMBER_STRING           @"1"
#define PRODUCT_PARAM                   @"narrator"


// Compile-time switches:

#define SHOW_SPLASH                     0
#define IS_FREEWARE                     0
#define IS_DEJAL_PRODUCT                1
#define USE_LICENSE_EDITOR              1
#define USE_KAGI_KRM                    1
#define USE_TRIALPAY                    1


// License trial period:

#define LICENSE_TRIAL_WARNING_DAYS      7
#define LICENSE_TRIAL_EXPIRY_DAYS       14


// Mac OS X version that is too old to use this product: NSAppKitVersionNumber10_4 means 10.5 required:

#define TOO_OLD_OS_VERSION              NSAppKitVersionNumber10_4
#define MINIMUM_OS_VERSION_STRING       @"10.5"


// Quit confirmation is a standard option for all apps, via the Special pref pane:

#define CONFIRM_QUIT_TITLE              NSLocalizedStringFromTable(@"Are you sure you want to quit Narrator?", @"Specific", @"Quit confirmation title")
#define CONFIRM_QUIT_MESSAGE            NSLocalizedStringFromTable(@"This confirmation can be disabled via the General Preferences, or check Don't ask again.", @"Specific", @"Quit confirmation explanation")
#define CONFIRM_QUIT_DEFAULT            NO


// Preferences Restore Defaults confirmation; specify nil for the title and message to use the default values:

#define CONFIRM_PREFS_TITLE             nil
#define CONFIRM_PREFS_MESSAGE           nil
#define CONFIRM_PREFS_DEFAULT           YES


// License stage and kind names:

#define LICENSE_STR_STAGE_BASIC         NSLocalizedStringFromTable(@"Individual", @"Specific", @"License stage")
#define LICENSE_STR_STAGE_STANDARD      NSLocalizedStringFromTable(@"Household", @"Specific", @"License stage")
#define LICENSE_STR_STAGE_ENTERPRISE	NSLocalizedStringFromTable(@"Site", @"Specific", @"License stage")

#define LICENSE_STR_KIND_BASIC          NSLocalizedStringFromTable(@"Individual License", @"Specific", @"License kind")
#define LICENSE_STR_KIND_STANDARD       NSLocalizedStringFromTable(@"Household License", @"Specific", @"License kind")
#define LICENSE_STR_KIND_ENTERPRISE     NSLocalizedStringFromTable(@"Site License", @"Specific", @"License kind")
#define LICENSE_STR_KIND_BASIC_TO_STD	NSLocalizedStringFromTable(@"Individual to Household", @"Specific", @"License kind")
#define LICENSE_STR_KIND_STD_TO_ENT     NSLocalizedStringFromTable(@"Household to Site", @"Specific", @"License kind")
#define LICENSE_STR_KIND_UPGRADE        NSLocalizedStringFromTable(@"Upgrade", @"Specific", @"License kind")
#define LICENSE_STR_KIND_REVIEW         NSLocalizedStringFromTable(@"Review", @"Specific", @"License kind")

#define LICENSE_STR_DESCR_BASIC         NSLocalizedStringFromTable(@"For a single user", @"Specific", @"License description")
#define LICENSE_STR_DESCR_STANDARD      NSLocalizedStringFromTable(@"For all people in your household", @"Specific", @"License description")
#define LICENSE_STR_DESCR_ENTERPRISE    NSLocalizedStringFromTable(@"For all users in your organization", @"Specific", @"License description")
#define LICENSE_STR_DESCR_BASIC_TO_STD  NSLocalizedStringFromTable(@"n/a", @"Specific", @"License description")
#define LICENSE_STR_DESCR_STD_TO_ENT    NSLocalizedStringFromTable(@"n/a", @"Specific", @"License description")
#define LICENSE_STR_DESCR_UPGRADE       NSLocalizedStringFromTable(@"Upgrade Narrator 1 to version 2", @"Specific", @"License description")

