//
//  Version1Characters.h
//  Narrator
//
//  Created by David Sinclair on Wed May 15 2002.
//  Copyright (c) 2002 Dejal Systems, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface Character : NSObject <NSCoding>
{
    NSNumber *version;
    NSString *name;
    NSString *voice;
    NSNumber *rate;
    NSNumber *pitch;
    NSNumber *inflection;
    NSNumber *volume;
    NSColor *marker;
}

/*  Initialization and De-Allocation  */
- (id)init;
- (void)dealloc;

/*  Archiving and Unarchiving  */
- (void)encodeWithCoder:(NSCoder *) coder;
- (id)initWithCoder:(NSCoder *)coder;

/*  Accessor Methods  */
- (NSString *)name;
- (void)setName:(NSString *)value;

- (NSString *)voice;
- (void)setVoice:(NSString *)value;

- (NSNumber *)rate;
- (void)setRate:(NSNumber *)value;

- (NSNumber *)pitch;
- (void)setPitch:(NSNumber *)value;

- (NSNumber *)inflection;
- (void)setInflection:(NSNumber *)value;

- (NSNumber *)volume;
- (void)setVolume:(NSNumber *)value;

- (NSColor *)marker;
- (void)setMarker:(NSColor *)value;

@end

@interface Cast : NSObject <NSCoding>
{
    NSAttributedString *nativeText;
    NSMutableArray *characters;
    NSMutableDictionary *config;
}

// Accessors
- (NSAttributedString *)nativeText;
- (void)setNativeText:(NSAttributedString *)value;

- (NSMutableArray *)characters;
- (void)setCharacters:(NSMutableArray *)value;

- (NSMutableDictionary *)config;
- (void)setConfig:(NSMutableDictionary *)value;

@end

