//
//  NarratorDocument.h
//  Narrator
//
//  Created by David Sinclair on 2007-10-08.
//  Copyright (c) 2002 - 2008 Dejal Systems, LLC. All rights reserved.
//

#import "NarratorTextView.h"
#import "DSTableView.h"


@class DocumentEntity, ChapterEntity, DSLicenseWindowButton;


@interface NarratorDocument : NSPersistentDocument
{
    IBOutlet NSWindow *speechWindow;
    IBOutlet NSSplitView *documentSplitView;
    IBOutlet NSSplitView *sourceSplitView;
    IBOutlet NarratorTextView *speechTextView;
    IBOutlet DSTableView *chaptersTableView;
    IBOutlet DSTableView *charactersTableView;
    IBOutlet NSPopUpButton *characterActorPopup;
    IBOutlet NSColorWell *characterColorWell;
    IBOutlet NSArrayController *chapterArrayController;
    IBOutlet NSArrayController *characterArrayController;
    
    DocumentEntity *documentEntity;
}

@property(readonly) DocumentEntity *documentEntity;
@property NSWindow *speechWindow;

- (DocumentEntity *)documentEntity;
- (ChapterEntity *)setupDefaultChapter;
- (void)setupDefaultCharacters;
- (void)clearChangeIndications;
- (void)setupSpeechTextView;
- (void)replaceCurrentChapterTextWithAttributedString:(NSAttributedString *)text;

- (IBAction)newChapter:(id)sender;
- (IBAction)newCharacter:(id)sender;
- (IBAction)playPauseNextCapsule:(id)sender;
- (IBAction)playStopSpeech:(id)sender;
- (IBAction)pauseResumeSpeech:(id)sender;
- (IBAction)nextSpeech:(id)sender;
- (IBAction)assignCharacter:(id)sender;
- (IBAction)resetRate:(id)sender;
- (IBAction)resetPitch:(id)sender;
- (IBAction)resetInflection:(id)sender;
- (IBAction)resetVolume:(id)sender;
- (IBAction)deselectAll:(id)sender;
- (IBAction)castingAssistant:(id)sender;
- (IBAction)search:(id)sender;
- (IBAction)quickLook:(id)sender;
- (IBAction)tellJoke:(id)sender;
- (IBAction)exportAsAAC:(id)sender;
- (IBAction)exportToITunes:(id)sender;

@end

