//
//  AbstractPersonEntity.m
//  Narrator
//
//  Created by David Sinclair on 2007-10-18.
//  Copyright (c) 2007 Dejal Systems, LLC. All rights reserved.
//

#import "AbstractPersonEntity.h"
#import "MainDefines.h"
#import "VoiceEntity.h"


@implementation AbstractPersonEntity

@dynamic identifier, name, comment, color, tableImage, fullImage, voice, locked;

- (void)awakeFromInsert;
{
    [super awakeFromInsert];
    
    NSManagedObjectContext *managedObjectContext = [self managedObjectContext];
    CGFloat hue = (CGFloat)DSRandomRange(0, 32767) / 32767.0;
    NSColor *color = [NSColor colorWithCalibratedHue:hue saturation:0.25 brightness:1.0 alpha:1.0];
    
    self.identifier = [NSString universallyUniqueIdentifier];
    self.color = color;
    self.tableImage = [NSImage imageNamed:@"NSUser"];
    self.voice = [NSEntityDescription insertNewObjectForEntityForName:@"Voice" inManagedObjectContext:managedObjectContext];
    self.voice.person = self;
}

@end

