//
//  CharacterEntity.h
//  Narrator
//
//  Created by David Sinclair on 2007-10-16.
//  Copyright (c) 2007 Dejal Systems, LLC. All rights reserved.
//

#import "AbstractPersonEntity.h"


@interface CharacterEntity : AbstractPersonEntity
{
}

@property(copy) NSString *actorName;
@property(copy) NSString *voiceName;
@property CharacterEntity *parent;  // Not currently used; present to allow an emotion for each character in the future
@property(copy) NSArray *children;  // Not currently used; present to allow an emotion for each character in the future

+ (CharacterEntity *)insertCharacterWithIdentifier:(NSString *)characterIdentifier name:(NSString *)characterName color:(NSColor *)characterColor
                                   voiceIdentifier:(NSString *)voiceIdentifier inContext:(NSManagedObjectContext *)context;

//- (NSString *)rateTitle;

- (BOOL)isSilent;
- (BOOL)isSilentReadAlong;
- (BOOL)isSilentSkipOver;

@end

