//
//  MTCDUtilities.h
//  MTCoreData
//
//  Created by David Sinclair on 2007-10-05.
//  From the Intro to Core Data part 3 article in MacTech magazine, Nov 2005.
//

#import <Cocoa/Cocoa.h>

#define MTTooManyEntitiesReturnedException @"Too many entities returned"
#define MTCoreDataException @"Core Data exception"


@interface MTCDUtilities : NSObject
{
}

+ (NSUInteger)countObjectsForEntityNamed:(NSString *)name inContext:(NSManagedObjectContext *)context;
+ (NSArray *)objectsForEntityNamed:(NSString *)name inContext:(NSManagedObjectContext *)context;
+ (NSManagedObject *)objectForEntityNamed:(NSString *)name inContext:(NSManagedObjectContext *)context;
+ (NSArray *)objectsForEntityNamed:(NSString *)name matchingKey:(NSString *)key andValue:(id)value inContext:(NSManagedObjectContext *)context;
+ (NSManagedObject *)objectForEntityNamed:(NSString *)name matchingKey:(NSString *)key andValue:(id)value inContext:(NSManagedObjectContext *)context;
+ (NSArray *)objectsForEntityNamed:(NSString *)name matchingKeysAndValues:(NSDictionary *)keyValues usingOR:(BOOL)useOR inContext:(NSManagedObjectContext *)context;

@end
