//
//  VoiceEntity.h
//  Narrator
//
//  Created by David Sinclair on 2007-11-09.
//  Copyright 2007 Dejal Systems, LLC. All rights reserved.
//

@class AbstractPersonEntity;
@class VoiceEntity;


@interface VoiceEntity : NSManagedObject
{
}

@property(copy) NSString *identifier;
@property(copy) NSString *name;
@property(copy) NSNumber *age;
@property(copy) NSString *gender;
@property(copy) NSString *language;
@property(copy) NSNumber *pitch;
@property(copy) NSNumber *rate;
@property(copy) NSNumber *inflection;
@property(copy) NSNumber *volume;
@property AbstractPersonEntity *person;
@property VoiceEntity *parent;      // Not currently used
@property(copy) NSArray *children;  // Not currently used
@property(copy) NSString *rateTitle;

- (void)resetProperty:(NSString *)propertyKey;

- (BOOL)isSilent;
- (BOOL)isSilentReadAlong;
- (BOOL)isSilentSkipOver;

@end

