//
//  CharacterAttachmentCell.h
//  Narrator
//
//  Created by David Sinclair on 2007-11-05.
//  Copyright 2007 Dejal Systems, LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@protocol CharacterAttachmentProtocol

- (NSString *)characterNameForIdentifier:(NSString *)identifier;
- (NSColor *)characterColorForIdentifier:(NSString *)identifier;

@end


@interface CharacterAttachmentCell : NSTextAttachmentCell
{
    NSString *identifier;
    NSString *name;
    NSColor *color;
    id <CharacterAttachmentProtocol> delegate;
}

@property(copy) NSString *identifier;
@property(copy) NSString *name;
@property(copy) NSColor *color;
@property(assign) id delegate;

+ (NSImage *)imageWithName:(NSString *)newName color:(NSColor *)newColor;

- (void)drawWithFrame:(NSRect)frame;

- (NSString *)name;
- (void)setName:(NSString *)value;

- (NSColor *)color;
- (void)setColor:(NSColor *)value;

@end

