//
//  NarratorTextView.m
//  Narrator
//
//  Created by David Sinclair on 2007-11-05.
//  Copyright 2007 Dejal Systems, LLC. All rights reserved.
//

#import "NarratorTextView.h"
#import "CharacterAttachmentCell.h"
#import "MainDefines.h"


@implementation NarratorTextView

@synthesize colorWell;

- (void)changeColor:(id)sender;
{
    if ([[self colorWell] isActive])
        [[self window] makeFirstResponder:[self colorWell]];
    else
        [super changeColor:sender];
}

- (BOOL)becomeFirstResponder;
{
    if ([[self colorWell] isActive])
        [[self colorWell] deactivate];
    
    return [super becomeFirstResponder];
}

- (void)informDelegateOfAction:(SEL)selector;
{
    if ([[self delegate] respondsToSelector:@selector(textView:willPerformAction:)])
        [[self delegate] textView:self willPerformAction:selector];
}

- (void)toggleContinuousSpellChecking:(id)sender;
{
    [super toggleContinuousSpellChecking:sender];
    [self informDelegateOfAction:_cmd];
}

- (void)toggleGrammarChecking:(id)sender;
{
    [super toggleGrammarChecking:sender];
    [self informDelegateOfAction:_cmd];
}

- (void)toggleRuler:(id)sender;
{
    [super toggleRuler:sender];
    [self informDelegateOfAction:_cmd];
}

- (void)toggleSmartInsertDelete:(id)sender;
{
    [super toggleSmartInsertDelete:sender];
    [self informDelegateOfAction:_cmd];
}

- (void)toggleAutomaticQuoteSubstitution:(id)sender;
{
    [super toggleAutomaticQuoteSubstitution:sender];
    [self informDelegateOfAction:_cmd];
}

- (void)toggleAutomaticLinkDetection:(id)sender;
{
    [super toggleAutomaticLinkDetection:sender];
    [self informDelegateOfAction:_cmd];
}

- (void)changeFont:(id)sender;
{
    [super changeFont:sender];
    [self informDelegateOfAction:_cmd];
}

// works, using arbitary data:
//- (NSFileWrapper *)fileWrapperWithIdentifier:(NSString *)identifier;
//{
//    NSString *wrapName = [identifier stringByAppendingPathExtension:@"narratorcharacter"];
//    NSData *data = [wrapName dataUsingEncoding:NSUTF8StringEncoding];
//    NSFileWrapper *wrapper = [[NSFileWrapper alloc] initRegularFileWithContents:data];
//    
//    [wrapper setFilename:wrapName];
//    [wrapper setPreferredFilename:wrapName];
//    
//    return wrapper;
//}
//
//- (void)insertCharacterMarkerWithIdentifier:(NSString *)identifier;
//{
//    NSFileWrapper *wrapper = [self fileWrapperWithIdentifier:identifier];
//    NSTextAttachment *attachment = [[NSTextAttachment alloc] initWithFileWrapper:wrapper];
//    CharacterAttachmentCell *cell = [CharacterAttachmentCell new];
//    
//    cell.identifier = identifier;
//    [attachment setAttachmentCell:cell];
//    
//    [[self textStorage] appendAttributedString:[NSAttributedString attributedStringWithAttachment:attachment]];
//}

// works, using an image:
//- (void)insertCharacterMarkerWithIdentifier:(NSString *)identifier;
//{
//    /*  // http://www.cocoadev.com/index.pl?NSTextAttachment
//     NSString * imgName = @"my_image.tif";
//     NSFileWrapper *fwrap = [[[NSFileWrapper alloc] initRegularFileWithContents:
//     [[NSImage imageNamed:@"my_image"] TIFFRepresentation]] autorelease];
//     [fwrap setFilename:imgName];
//     [fwrap setPreferredFilename:imgName];
//     */
//    
//    NSString *wrapName = [identifier stringByAppendingPathExtension:@"tiff"];
//    //    NSString *wrapName = [identifier stringByAppendingPathExtension:@"narratorcharacter"];
//    //    NSData *data = [wrapName dataUsingEncoding:NSUTF8StringEncoding];
//    
//    NSSize size = {100, 18};
//    NSImage *image = [[NSImage alloc] initWithSize:size];
//    
//    [image lockFocus];
//    
//    [[NSColor grayColor] set];
//    NSRectFill(NSMakeRect(0, 0, size.width, size.height));
//    
//    [image unlockFocus];
//    
//    NSData *data = [image TIFFRepresentation];
//    
//    NSFileWrapper *wrapper = [[NSFileWrapper alloc] initRegularFileWithContents:data];
//    
//    [wrapper setFilename:wrapName];
//    [wrapper setPreferredFilename:wrapName];
//    
//    NSTextAttachment *attachment = [[NSTextAttachment alloc] initWithFileWrapper:wrapper];
//    CharacterAttachmentCell *cell = [CharacterAttachmentCell new];
//    cell.image = image;
//    cell.identifier = identifier;
//    [attachment setAttachmentCell:cell];
//    
//    NSTextStorage* textStorage = [self textStorage];
//    
//    [textStorage beginEditing];
//    [textStorage appendAttributedString:[NSAttributedString attributedStringWithAttachment:attachment]];
//    
//    [textStorage appendAttributedString:[NSAttributedString attributedStringWithString:@"[TESTING]"]];        // hack
//    
//    attachment = [[NSTextAttachment alloc] initWithFileWrapper:[[NSFileWrapper alloc] initWithPath:[[NSBundle mainBundle] pathForResource:@"Narrator" ofType:@"icns"]]];  // hack
//    [textStorage appendAttributedString:[NSAttributedString attributedStringWithAttachment:attachment]];
//    [textStorage endEditing];
//}

//- (void)insertCharacterMarkerWithIdentifier:(NSString *)identifier;
//{
//    NSString *path = [MainController temporaryDataPath];
//    
//    path = [[path stringByAppendingPathComponent:identifier] stringByAppendingPathExtension:@"narratorcharacter"];
//    
//    [identifier writeToFile:path atomically:NO encoding:NSUTF8StringEncoding error:nil];
//    
//    NSFileWrapper *wrapper = [[NSFileWrapper alloc] initWithPath:path];
//    
//    //    NSTextAttachment *attachment = [[NSTextAttachment alloc] initWithFileWrapper:nil];
//    NSTextAttachment *attachment = [[NSTextAttachment alloc] initWithFileWrapper:wrapper];
//    CharacterAttachmentCell *cell = [CharacterAttachmentCell new];
//    cell.identifier = identifier;
//    [attachment setAttachmentCell:cell];
//    
//    NSTextStorage* textStorage = [self textStorage];
//    
//    [textStorage beginEditing];
//    [textStorage appendAttributedString:[NSAttributedString attributedStringWithAttachment:attachment]];
//    
//    [textStorage appendAttributedString:[NSAttributedString attributedStringWithString:@"[TESTING]"]];        // hack
//    
//    attachment = [[NSTextAttachment alloc] initWithFileWrapper:[[NSFileWrapper alloc] initWithPath:[[NSBundle mainBundle] pathForResource:@"Narrator" ofType:@"icns"]]];  // hack
//    [textStorage appendAttributedString:[NSAttributedString attributedStringWithAttachment:attachment]];
//    [textStorage endEditing];
//}

//- (NSArray *)readablePasteboardTypes;
//{
//    NSMutableArray *types = [NSMutableArray arrayWithArray:[super readablePasteboardTypes]];
//    
//    [types insertObject:kCharacterMarkerPboardType atIndex:0];
//    
//    return types;
//}
//
//- (NSArray *)writablePasteboardTypes;
//{
//    NSMutableArray *types = [NSMutableArray arrayWithArray:[super writablePasteboardTypes]];
//    
//    [types insertObject:kCharacterMarkerPboardType atIndex:0];
//    
//    return types;
//}
//
//- (NSArray *)acceptableDragTypes;
//{
//    NSMutableArray *types = [NSMutableArray arrayWithArray:[super acceptableDragTypes]];
//    
//    [types insertObject:kCharacterMarkerPboardType atIndex:0];
//    
//    return types;
//}
//
//// may need to override -performDragOperation: etc too
//
//- (BOOL)readSelectionFromPasteboard:(NSPasteboard *)pboard type:(NSString *)type;
//{
//    if ([type isEqualToString:kCharacterMarkerPboardType])
//    {
// //       NSRange range = [self rangeForUserTextChange];
//        
//        NSString *identifier = [pboard stringForType:type];
//        
//        [self insertCharacterMarkerWithIdentifier:identifier];
//        
//        return YES;
//    }
//    else
//        return [super readSelectionFromPasteboard:pboard type:type];
//}

/*
- (BOOL)writeSelectionToPasteboard:(NSPasteboard *)pboard type:(NSString *)type;
{
    if ([type isEqualToString:kCharacterMarkerPboardType])
    {
        NSString *identifier = ;
        
        [pboard setString:identifier forType:type];
        
        return YES;
    }
    else
        return [super writeSelectionToPasteboard:pboard type:type];
}
*/

@end

